function wellTableOnLoad()
{
    //invoke state-select change events to load meridian/county partial page(s)
    dojo.query('.stSelect').forEach(function(select) {
      if (typeof(select.onchange) == 'function')
        select.onchange();
    });
    
    
}

function wellTableOnSave()
{
    var i=1;
    var merObj = document.getElementById('well_locations'+i+'SelectedMeridian');
    var ctyObj = document.getElementById('well_locations'+i+'SelectedCounty');
    while (merObj) 
    {
        var ppMerObj = dojo.query('.ppMerSelect', document.getElementById('well_locations'+i+'ppg_MerCounty'))[0];
        var ppCtyObj = dojo.query('.ppCtySelect', document.getElementById('well_locations'+i+'ppg_MerCounty'))[0];
        if (ppMerObj)
            merObj.value = ppMerObj.value;
        if (ppCtyObj)
            ctyObj.value = ppCtyObj.value;
        i++;
        merObj = document.getElementById('well_locations'+i+'SelectedMeridian');
        ctyObj = document.getElementById('well_locations'+i+'SelectedCounty');
    }
}

function checkLeaseType(repeatID)
{
    var leaseType = getRadioCheckedValue(repeatID+'rbLeaseType');
    if(leaseType == 'FEE' || leaseType == 'STATE')
        document.getElementById(repeatID+'txtLeaseNr').value = leaseType;
}

function wellClassChange()
{
    if(getRadioCheckedValue('rbWellClass') != document.getElementById('wellClassMultiLat').value)  {
        if(document.getElementById('txtNumLegs').value != '1')  {
            document.getElementById('txtNumLegs').value = '1';
        }
    }
    if (document.getElementById('txtNumLegs').value != document.getElementById('prevWellLegs').value) //change in leg number
        document.getElementById('updateWellTable').value = 'YES';
    else
        document.getElementById('updateWellTable').value = 'NO';
}

function validateApp(pageNum)
{
    var pctCompleted = 0.0;
    var missingFields = 0;
    var fieldCount;
    switch (pageNum)
    {
    case '1':
        fieldCount = 4; //before conditionals
        if(!validateSelect('selBLMOffice', 'BLM Office')) missingFields++;
        if(!validateMultiCheck('rbLeaseType', 'Federal/Indian APD')) missingFields++;
        if(isValueSelected('rbLeaseType', 'IND')) {
            fieldCount += 2;
            if(!validateRadio('rbSAA', 'Surface access agreement in place?')) missingFields++;
            if(!validateRadio('rbAllotted', 'Allotted?')) missingFields++;
            if(getRadioCheckedValue('rbAllotted') == 'NO') {
                fieldCount++;
                if(!validateSelect('selReservation', 'Reservation')) missingFields++;
            }
        }
        if(!validateRadio('rbAgreement', 'Agreement in place?')) missingFields++;
        if(getRadioCheckedValue('rbAgreement') == 'YES') {
            fieldCount ++;
            if(!validateRadio('rbAgreeType', 'Federal or Indian agreement')) 
                missingFields++;
            else {
                fieldCount += 2;
                if(!validateText('txtAgreeNum', 'Agreement number')) missingFields++;
                if(!validateText('txtAgreeName', 'Agreement name')) missingFields++;
            }
        }
        if(!validateRadio('rbConfidential', 'Keep application confidential?')) missingFields++;
        if(getRadioCheckedValue('rbDesignated') == 'DESIGNATED AGENT') {
            fieldCount++;
            if(!validateText('txtOperLetter', 'Operator letter of designation')) missingFields++;
        }
        break;
    case '2':
        fieldCount =20;
        if(!validateRadio('rbMDev', 'Master Development Plan?')) missingFields++;
        if(getRadioCheckedValue('rbMDev') == 'New') {
            fieldCount++;
            if(!validateText('txtNewMasterName', 'New Master Development Plan name')) missingFields++;
        }
        if(getRadioCheckedValue('rbMDev') == 'Exist') {
            fieldCount++;
            if(!validateSelect('selMasterName', 'Master Development Plan name')) missingFields++;
        }
        if(!validateRadio('rbMSupo', 'Master SUPO?')) missingFields++;
        if(getRadioCheckedValue('rbMSupo') == 'New') {
            fieldCount++;
            if(!validateText('txtNewSUPOName', 'New Master SUPO name')) missingFields++;
        }
        if(getRadioCheckedValue('rbMSupo') == 'Exist') {
            fieldCount++;
            if(!validateSelect('selSUPOName', 'Master SUPO name')) missingFields++;
        }
        if(!validateRadio('rbMDrill', 'Master Drilling Plan?')) missingFields++;
        if(getRadioCheckedValue('rbMDrill') == 'New') {
            fieldCount++;
            if(!validateText('txtNewDPName', 'New Master Drilling Plan name')) missingFields++;
        }
        if(getRadioCheckedValue('rbMDrill') == 'Exist') {
            fieldCount++;
            if(!validateSelect('selDPName', 'Master Drilling Plan name')) missingFields++;
        }
        if(!validateText('txtWellName', 'Well Name')) missingFields++;
        if(!validateText('txtWellNum', 'Well Number')) missingFields++;
        //if(!validateText('txtAPINum', 'Well API Number')) missingFields++;
        if(!validateRadio('rbFieldPool', 'Field/Pool or Exploratory?')) missingFields++;
        if(getRadioCheckedValue('rbFieldPool') == 'FP') {
            fieldCount++;
            if(!validateText('txtField', 'Field Name')) missingFields++;
        }
        if(!validateMultiCheck('chkMinerals', 'Other minieral resources?')) missingFields++;
        if(!validateRadio('rbHeliumArea', 'Helium production area?')) missingFields++;
        if(!validateRadio('rbExistPad', 'Use Existing Well Pad?')) missingFields++;
        if(getRadioCheckedValue('rbExistPad') == 'Y') {
            fieldCount++;
            if(!validateRadio('rbNewDisturbance', 'New surface disturbance?')) missingFields++;
        }
        if(!validateRadio('rbPadType', 'Type of Well Pad')) missingFields++;
        if(!validateRadio('rbWellClass', 'Well Class')) missingFields++;
        if(getRadioCheckedValue('rbWellClass') == document.getElementById('wellClassMultiLat').value)  {
            fieldCount++;
            if(!validateText('txtNumLegs', 'Number of multilateral legs')) missingFields++;
        }
        if(!validateRadio('rbWorkType', 'Work Type')) missingFields++;
        if(!validateSelect('selWellType', 'Well Type')) missingFields++;
        if(!validateSelect('selSubType', 'Well sub-type')) missingFields++;
        //optional - if(!validateText('txtDistToTown', 'Distance to town')) missingFields++;
        if(!validateText('txtDistToWell', 'Distance to nearest well')) missingFields++;
        if(!validateText('txtDistToLease', 'Distance to lease line')) missingFields++;
        if(!validateText('txtAcreSpacing', 'Reservoir well spacing acres measurement')) missingFields++;
//validate well plat file is uploaded
        if(!validateText('dteWorkStart', 'Well work start date')) missingFields++;
        if(!validateText('txtWorkDuration', 'Duration')) missingFields++;
        break;
    case '3':
        fieldCount = 3;
        if(!validateSelect('selSurvey', 'Survey Type')) missingFields++;
        if(!validateRadio('rbDatum', 'Datum')) missingFields++;
        if(!validateRadio('rbVDatum', 'Vertical Datum')) missingFields++;
        //if(!validateText('txtSurveyNum', 'Survey Number')) missingFields++;
        //loop through well locatoin records
        var i = 1;
        var repeatID = 'well_locations';
        var locType;
        var legNum;
        var legMsg;
        var rowObj = document.getElementById(repeatID+i+'oWellTabType');
        while(rowObj != null)
        {
            locType = document.getElementById(repeatID+i+'oWellTabType').innerHTML;
            legNum = document.getElementById(repeatID+i+'oLeg').innerHTML;
            if (locType == 'SHL')
                legMsg = '';
            else
                legMsg = '('+legNum+')';
            //validate the row
            fieldCount += 7;
            if(!validateSelect(repeatID+i+'selState', locType+legMsg+' State')) missingFields++;
            //if(!validateSelect(repeatID+i+'selMeridian', locType+legMsg+' Meridian')) missingFields++;
            //if(!validateSelect(repeatID+i+'selCounty', locType+legMsg+' County')) missingFields++;
            if(!validateText(repeatID+i+'txtLat', locType+legMsg+' Latitude')) missingFields++;
            if(!validateText(repeatID+i+'txtLong', locType+legMsg+' Longitude')) missingFields++;
            if(!validateText(repeatID+i+'txtElevation', locType+legMsg+' Elevation')) missingFields++;
            if(!validateText(repeatID+i+'txtMD', locType+legMsg+' MD')) missingFields++;
            if(!validateText(repeatID+i+'txtTVD', locType+legMsg+' TVD')) missingFields++;
            if(!validateRadio(repeatID+i+'rbLeaseType', locType+legMsg+' Lease Type')) missingFields++;
            //conditional fields
            surveyType = document.getElementById(repeatID+i+'Survey').value;
            switch (surveyType)
            {
            case '1':  //rectangular
                fieldCount += 8;
                if(!validateText(repeatID+i+'txtNSFoot', locType+legMsg+' NS-Foot')) missingFields++;
                if(!validateRadio(repeatID+i+'rbNSInd', locType+legMsg+' NS-Foot indicator')) missingFields++;
                if(!validateText(repeatID+i+'txtEWFoot', locType+legMsg+' EW-Foot')) missingFields++;
                if(!validateRadio(repeatID+i+'rbEWInd', locType+legMsg+' EW-Foot indicator')) missingFields++;
                if(!validateText(repeatID+i+'txtTwsp', locType+legMsg+' Township')) missingFields++;
                if(!validateText(repeatID+i+'txtRange', locType+legMsg+' Range')) missingFields++;
                if(!validateText(repeatID+i+'txtSection', locType+legMsg+' Section')) missingFields++;
                if(!validateALT(repeatID+i, locType+legMsg+' Aliquot, Lot or Tract')) missingFields++;
                break;
            case '2':  //Metes & Bounds
                fieldCount++;
                if(!validateText(repeatID+i+'txtMetesBounds', locType+legMsg+' Metes and Bounds')) missingFields++;
                break;
            case '3':  //Carter coord
                break;
                fieldCount += 7;
                if(!validateText(repeatID+i+'txtNSFoot', locType+legMsg+' NS-Foot')) missingFields++;
                if(!validateRadio(repeatID+i+'rbNSInd', locType+legMsg+' NS-Foot indicator')) missingFields++;
                if(!validateText(repeatID+i+'txtEWFoot', locType+legMsg+' EW-Foot')) missingFields++;
                if(!validateRadio(repeatID+i+'rbEWInd', locType+legMsg+' EW-Foot indicator')) missingFields++;
                if(!validateText(repeatID+i+'txt5MinLetter', locType+legMsg+' 5 Min Letter')) missingFields++;
                if(!validateText(repeatID+i+'txt5MinNum', locType+legMsg+' 5 Min Number')) missingFields++;
                if(!validateText(repeatID+i+'txt1MinSect', locType+legMsg+' 1 Min Section')) missingFields++;
                break;
            default:
                break;
            }
            //check for next row
            i++;
            rowObj = document.getElementById(repeatID+i+'oWellTabType');
        }

        break;
    }
    pctCompleted = parseFloat((fieldCount-missingFields)/fieldCount);
    return pctCompleted;
}

function validateALT(repeatID, friendlyName) //any one of aliquot, Lot, Tract
{
    if ((null == document.getElementById(repeatID+'txtAliquot').value || document.getElementById(repeatID+'txtAliquot').value == '') &&
        (null == document.getElementById(repeatID+'txtLot').value || document.getElementById(repeatID+'txtLot').value == '') &&
        (null == document.getElementById(repeatID+'txtTract').value || document.getElementById(repeatID+'txtTract').value == '')){
        validationMsg = validationMsg + '\n   '+friendlyName;
        return false;
    }
    return true;
}

function copyLeaseNumber(repeatID)  //lease number onChange
{
    //copy lease number to validation field
    document.getElementById('validationLeaseNumber').value = document.getElementById(repeatID+'txtLeaseNr').value;
    document.getElementById('repeatID').value = repeatID;
    //reset validation result
    hyf.util.hideComponent(document.getElementById(repeatID+'grpValidationPass'));
    hyf.util.hideComponent(document.getElementById(repeatID+'grpValidationFail'));
}

function showValidationResult()  //validation partial page onLoad function (leaseValidation)
{
    var repeatID = document.getElementById('repeatID').value;
    if(document.getElementById('validationResult').value == 'YES')
        hyf.util.showComponent(document.getElementById(repeatID+'grpValidationPass'));
    else {
        document.getElementById(repeatID+'oValidationMsg').innerHTML = document.getElementById('validationMsg').value;
        hyf.util.showComponent(document.getElementById(repeatID+'grpValidationFail'));
        document.getElementById(repeatID+'txtLeaseNr').value = '';
    }
}

function initializeLeaseValidations()
{
    var i = 1;
    var typeObj = document.getElementById('well_locations'+i+'rbLeaseType');
    while(typeObj != null)
    {
        if(getRadioCheckedValue('well_locations'+i+'rbLeaseType') == 'FEDERAL') {
            valMsg = document.getElementById('well_locations'+i+'txtValidLease').value;
            if(valMsg == 'YES')
                hyf.util.showComponent(document.getElementById('well_locations'+i+'grpValidationPass'));
            else 
                hyf.util.showComponent(document.getElementById('well_locations'+i+'grpValidationFail'));
        }
        i++;
        typeObj = document.getElementById('well_locations'+i+'rbLeaseType');
    }
}
function copyAgreementNumber()  //agreement number onChange
{
    //copy number to validation field
    document.getElementById('validationAgreementNumber').value = document.getElementById('txtAgreeNum').value;
    //reset validation result
    hyf.util.hideComponent(document.getElementById('grpValidationPass'));
    hyf.util.hideComponent(document.getElementById('grpValidationFail'));
}

function showValidAgreeResult()  //validation partial page onLoad function (agreementValidation)
{
    if(document.getElementById('validationResult').value == 'YES')
        hyf.util.showComponent(document.getElementById('grpValidationPass'));
    else {
        document.getElementById('validationResultMsg').innerHTML = document.getElementById('validationMsg').value;
        hyf.util.showComponent(document.getElementById('grpValidationFail'));
        document.getElementById('txtAgreeNum').value = '';
    }
}

function initializeAgreementValidation()  //redisplay validation result on load
{
    var valResult = document.getElementById('txtValid').value;
    //alert('init validation: valid='+valResult+'  agreetype='+getRadioCheckedValue('rbAgreeType'));
    if(getRadioCheckedValue('rbAgreeType') == '1' && document.getElementById('txtAgreeNum').value != '') {
        if(valResult == 'YES')
            hyf.util.showComponent(document.getElementById('grpValidationPass'));
        else 
            hyf.util.showComponent(document.getElementById('grpValidationFail'));
    }
}

function onChangeALT(sourceID, repeatID)
{
    switch (sourceID)
    {
        case 'A':   //aliquot entered
            if(validateText(repeatID+'txtAliquot','')) {
                document.getElementById(repeatID+'txtLot').value = '';
                document.getElementById(repeatID+'txtTract').value = '';
            }
            break;
        case 'L':   //aliquot entered
            if(validateText(repeatID+'txtLot','')) {
                document.getElementById(repeatID+'txtAliquot').value = '';
                document.getElementById(repeatID+'txtTract').value = '';
            }
            break;
        case 'T':   //aliquot entered
            if(validateText(repeatID+'txtTract','')) {
                document.getElementById(repeatID+'txtLot').value = '';
                document.getElementById(repeatID+'txtAliquot').value = '';
            }
            break;
    }
}
 
        
        
        
        
        
        
        